| BLDC control on ATAVRMC303 with ATxMega128A1

Macros | Functions
awex_driver.h File Reference

XMEGA AWeX driver header file. More...

`#include "avr_compiler.h"`
Include dependency graph for awex_driver.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros
#define | AWEX_ClearFaultFlag(_awex) ( _awex->STATUS = AWEX_FDF_bm )
| This macro clears the Fault Detected Flag. More...
#define | AWEX_DeadTimeBufferLowSideValid(_awex) ( _awex->STATUS & AWEX_DTLSBUFV_bm )
| This macro returns the state of the Low Side Dead Time Buffer. More...
#define | AWEX_DisableCommonWaveformChannelMode(_awex) ( _awex->CTRL &= ~AWEX_CWCM_bm )
| This macro disables the Common Waveform Channel mode. More...
#define | AWEX_DisablePatternGenerationMode(_awex) ( _awex->CTRL &= ~AWEX_PGM_bm )
| This macro disables the Pattern Generation Mode. More...
#define | AWEX_EnableCommonWaveformChannelMode(_awex) ( _awex.CTRL |= AWEX_CWCM_bm )
| This macro enables the Common Waveform Channel mode. More...
#define | AWEX_EnablePatternGenerationMode(_awex) ( _awex->CTRL |= AWEX_PGM_bm )
| This macro enables the Pattern Generation Mode. More...
#define | AWEX_IsDeadTimeBufferHighSideValid(_awex) ( _awex->STATUS & AWEX_DTHSBUFV_bm )
| This macro returns the state of the High Side Dead Time Buffer. More...
#define | AWEX_IsFaultDetected(_awex) ( _awex->STATUS & AWEX_FDF_bm )
| This macro returns the status of the Fault Detection. More...
#define | AWEX_SetDeadTimeAsymmetricalBuffered(_awex, _deadTimeLow, _deadTimeHigh)
| This macro sets the dead time for high and low side. More...
#define | AWEX_SetDeadTimeAsymmetricalUnbuffered(_awex, _deadTimeLow, _deadTimeHigh)
| This macro sets the dead time for high and low side. More...
#define | AWEX_SetDeadTimesSymmetricalBuffered(_awex, _deadTime) ( _awex.DTBOTHBUF = _deadTime )
| This macro sets an equal dead time for high and low side. More...
#define | AWEX_SetDeadTimesSymmetricalUnbuffered(_awex, _deadTime) ( _awex.DTBOTH = _deadTime )
| This macro sets an equal dead time for high and low side. More...
#define | AWEX_SetOutputOverrideValue(_awex, _overrideValue) ( _awex.OUTOVEN = _overrideValue )
| This macro sets an output override value. More...

## Functions
void | AWEX_ConfigureFaultDetection (AWEX_t *awex, AWEX_FDACT_t faultAction, uint8_t eventMask)
| This function configures the Fault Detection function for this AWEX. More...
void | AWEX_DisableDeadTimeInsertion (AWEX_t *awex, uint8_t disableMask)
| Disable Dead Time Insertion. More...
void | AWEX_EnableDeadTimeInsertion (AWEX_t *awex, uint8_t enableMask)
| Enable Dead Time Insertion. More...

## Detailed Description

XMEGA AWeX driver header file.

This file contains the function prototypes and enumerator definitions for various configuration parameters for the XMEGA AWeX driver.

The driver is not intended for size and/or speed critical code, since most functions are just a few lines of code, and the function call overhead would decrease code performance. The driver is intended for rapid prototyping and documentation purposes for getting started with the XMEGA AWeX module.

For size and/or speed critical code, it is recommended to copy the function contents directly into your application instead of making a function call.

Application note:
  AVR1311: Using the XMEGA Timer/Counter Extensions.

Documentation
  For comprehensive code documentation, supported compilers, compiler settings and supported devices see readme.html

Author
  Atmel Corporation: http://www.atmel.com
  Support email: avr@a.nosp@m.tmel.nosp@m..com

Revision
  1569

Date
  2008-04-22 13:03:43 +0200 (ti, 22 apr 2008)

Copyright (c) 2008, Atmel Corporation All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
3. The name of ATMEL may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Definition in file awex_driver.h.

## Macro Definition Documentation

## ◆ AWEX_ClearFaultFlag

#define AWEX_ClearFaultFlag | ( |  | _awex | ) | ( _awex->STATUS = AWEX_FDF_bm )

This macro clears the Fault Detected Flag.

Clearing this flag will not undo the Fault Detect action, only clear the flag.

Parameters

  _awex | The AWEX module.

Definition at line 118 of file awex_driver.h.

## ◆ AWEX_DeadTimeBufferLowSideValid

#define AWEX_DeadTimeBufferLowSideValid | ( |  | _awex | ) | ( _awex->STATUS & AWEX_DTLSBUFV_bm )

This macro returns the state of the Low Side Dead Time Buffer.

Parameters

  _awex | The AWEX module.

Returns
  Non-zero if the state of the Low Side Dead Time Buffer, zero otherwise.

Definition at line 137 of file awex_driver.h.

## ◆ AWEX_DisableCommonWaveformChannelMode

#define AWEX_DisableCommonWaveformChannelMode | ( |  | _awex | ) | ( _awex->CTRL &= ~AWEX_CWCM_bm )

This macro disables the Common Waveform Channel mode.

Parameters

  _awex | The AWEX module.

Definition at line 78 of file awex_driver.h.

## ◆ AWEX_DisablePatternGenerationMode

#define AWEX_DisablePatternGenerationMode | ( |  | _awex | ) | ( _awex->CTRL &= ~AWEX_PGM_bm )

This macro disables the Pattern Generation Mode.

Parameters

  _awex | The AWEX module.

Definition at line 92 of file awex_driver.h.

## ◆ AWEX_EnableCommonWaveformChannelMode

#define AWEX_EnableCommonWaveformChannelMode | ( |  | _awex | ) | ( _awex.CTRL |= AWEX_CWCM_bm )

This macro enables the Common Waveform Channel mode.

Parameters

  _awex | The AWEX module.

Definition at line 71 of file awex_driver.h.

Referenced by PWM_Init().

## ◆ AWEX_EnablePatternGenerationMode

#define AWEX_EnablePatternGenerationMode | ( |  | _awex | ) | ( _awex->CTRL |= AWEX_PGM_bm )

This macro enables the Pattern Generation Mode.

Parameters

  _awex | The AWEX module.

Definition at line 85 of file awex_driver.h.

## ◆ AWEX_IsDeadTimeBufferHighSideValid

#define AWEX_IsDeadTimeBufferHighSideValid | ( |  | _awex | ) | ( _awex->STATUS & AWEX_DTHSBUFV_bm )

This macro returns the state of the High Side Dead Time Buffer.

Parameters

  _awex | The AWEX module.

Returns
  Non-zero if the state of the High Side Dead Time Buffer, zero otherwise.

Definition at line 127 of file awex_driver.h.

## ◆ AWEX_IsFaultDetected

#define AWEX_IsFaultDetected | ( |  | _awex | ) | ( _awex->STATUS & AWEX_FDF_bm )

This macro returns the status of the Fault Detection.

Parameters

  _awex | The AWEX module.

Returns
  The Fault Detection status.

Definition at line 109 of file awex_driver.h.

## ◆ AWEX_SetDeadTimeAsymmetricalBuffered

#define AWEX_SetDeadTimeAsymmetricalBuffered | ( |  | _awex,
|  |  | _deadTimeLow,
|  |  | _deadTimeHigh
| ) |  |

Value:
( _awex->DTLSBUF = _deadTimeLow; \
_awex->DTHSBUF = _deadTimeHigh )

This macro sets the dead time for high and low side.

When using this macro, the dead times are updated on the next UPDATE condition.

Parameters

  _awex | The AWEX module.
  _deadTimeLow | The dead time for low side.
  _deadTimeHigh | The dead time for high side.

Definition at line 182 of file awex_driver.h.

## ◆ AWEX_SetDeadTimeAsymmetricalUnbuffered

#define AWEX_SetDeadTimeAsymmetricalUnbuffered | ( |  | _awex,
|  |  | _deadTimeLow,
|  |  | _deadTimeHigh
| ) |  |

Value:
( _awex->DTLS = _deadTimeLow; \
_awex->DTHS = _deadTimeHigh )

This macro sets the dead time for high and low side.

When using this macro, the dead times are updated immediately.

Parameters

  _awex | The AWEX module.
  _deadTimeLow | The dead time for low side.
  _deadTimeHigh | The dead time for high side.

Definition at line 158 of file awex_driver.h.

## ◆ AWEX_SetDeadTimesSymmetricalBuffered

#define AWEX_SetDeadTimesSymmetricalBuffered | ( |  | _awex,
|  |  | _deadTime
| ) |  | ( _awex.DTBOTHBUF = _deadTime )

This macro sets an equal dead time for high and low side.

When using this macro, the dead time is updated on the next UPDATE condition.

Parameters

  _awex | The AWEX module.
  _deadTime | The dead time.

Definition at line 170 of file awex_driver.h.

## ◆ AWEX_SetDeadTimesSymmetricalUnbuffered

#define AWEX_SetDeadTimesSymmetricalUnbuffered | ( |  | _awex,
|  |  | _deadTime
| ) |  | ( _awex.DTBOTH = _deadTime )

This macro sets an equal dead time for high and low side.

When using this macro, the dead time is updated immediately.

Parameters

  _awex | The AWEX module.
  _deadTime | The dead time.

Definition at line 147 of file awex_driver.h.

Referenced by ConfigDTI().

## ◆ AWEX_SetOutputOverrideValue

#define AWEX_SetOutputOverrideValue | ( |  | _awex,
|  |  | _overrideValue
| ) |  | ( _awex.OUTOVEN = _overrideValue )

This macro sets an output override value.

Parameters

  _awex | The AWEX module.
  _overrideValue | The override value to output.

Definition at line 100 of file awex_driver.h.

Referenced by ConfigDTI(), and PWM_Init().

## Function Documentation

## ◆ AWEX_ConfigureFaultDetection()

void AWEX_ConfigureFaultDetection | ( | AWEX_t * | awex,
|  | AWEX_FDACT_t | faultAction,
|  | uint8_t | eventMask
| ) |  |

This function configures the Fault Detection function for this AWEX.

Parameters

  awex | The AWEX module.
  faultAction | Action to perform on a fault condition.
  eventMask | Mask of event channels that will trigger a Fault.

Definition at line 117 of file awex_driver.c.

120 {
121 awex->FDCTRL = ( awex->FDCTRL & ~AWEX_FDACT_gm ) | faultAction;
122 awex->FDEMASK = eventMask;
123 }

## ◆ AWEX_DisableDeadTimeInsertion()

void AWEX_DisableDeadTimeInsertion | ( | AWEX_t * | awex,
|  | uint8_t | disableMask
| ) |  |

Disable Dead Time Insertion.

This function disables Dead Time Insertion for the channels selected in the disableMask. The disableMask can be obtained by ORing together the symbols

- AWEX_DTICCAEN_bm
- AWEX_DTICCBEN_bm
- AWEX_DTICCCEN_bm
- AWEX_DTICCDEN_bm

Parameters

  awex | The AWEX module.
  disableMask | Mask of channels to disable.

Definition at line 98 of file awex_driver.c.

99 {
100 /* Make sure only the DTI enable bits are affected. */
101 disableMask &= ( AWEX_DTICCAEN_bm |
102 AWEX_DTICCBEN_bm |
103 AWEX_DTICCCEN_bm |
104 AWEX_DTICCDEN_bm );
105
106 /* Disable DTI for the selected channels. */
107 awex->CTRL &= ~disableMask;
108 }

## ◆ AWEX_EnableDeadTimeInsertion()

void AWEX_EnableDeadTimeInsertion | ( | AWEX_t * | awex,
|  | uint8_t | enableMask
| ) |  |

Enable Dead Time Insertion.

This function enables Dead Time Insertion for the channels selected in the enableMask. The enableMask can be obtained by ORing together the symbols

- AWEX_DTICCAEN_bm
- AWEX_DTICCBEN_bm
- AWEX_DTICCCEN_bm
- AWEX_DTICCDEN_bm

Parameters

  awex | The AWEX module.
  enableMask | Mask of channels to enable.

Definition at line 73 of file awex_driver.c.

Referenced by ConfigDTI().

74 {
75 /* Make sure only the DTI enable bits are affected. */
76 enableMask &= ( AWEX_DTICCAEN_bm |
77 AWEX_DTICCBEN_bm |
78 AWEX_DTICCCEN_bm |
79 AWEX_DTICCDEN_bm );
80
81 /* Enable DTI for the selected channels. */
82 awex->CTRL |= enableMask;
83 }